%define build_test 0
%{?_with_test: %{expand: %%global build_test 1}}
%{?_without_test: %{expand: %%global build_test 0}}

%define bootstrap 1
%{?_without_bootstrap: %global bootstrap 0}
%{?_with_bootstrap: %global bootstrap 1}

# hardcode build_arch for imagemagick, otherwise it will run in to SIGFAULT
%define build_arch %(echo %{_target_cpu} | sed -e 's/_/-/')

# V E R S I O N   P A R T S

# their "official" version
%define rversion 7.0.7

# their "minor" version
%define minor_rev 0

# some other funny version
# (aw) from the docs: Versions with Q8 in the name are 8 bits-per-pixel
# component (e.g. 8-bit red, 8-bit green, etc.), whereas, Q16 in the
# filename are 16 bits-per-pixel component. A Q16 version permits you
# to read or write 16-bit images without losing precision but requires
# twice as much resources as the Q8 version.
%define qlev Q16
%define api 7

# the full file version
%define dversion %{rversion}-%{minor_rev}

%define major 4
%define cppmajor 3

%define libname %mklibname magick7Q16
%define develname %mklibname magick -d
 

Summary:        An X application for displaying and manipulating images
Name:           ImageMagick
Version:        %{rversion}.%{minor_rev}
Release:        %mkrel 5
License:        ASL 2.0
Group:          Graphics
URL:            http://www.imagemagick.org/
Source0:        http://www.imagemagick.org/download/ImageMagick-%{dversion}.tar.xz
Source1:        ImageMagick.pdf.bz2
Source10:       magick-icon_16x16.png
Source11:       magick-icon_32x32.png
Source12:       magick-icon_48x48.png
Source13:       magick-icon_64x64.png
#Patch0:         imagemagick-docdir.diff
Patch2:         ImageMagick-7.0.7-force-so.patch
Patch7:         imagemagick-urw.diff
Patch17:        imagemagick-fpx.diff
Patch19:        ImageMagick-libpath.diff
#Patch20:        ImageMagick-6.9.5-0-fix-montageimages-test.patch

Requires:       %{libname} = %{version}
Provides:       ImageMagick = %{version}-%{release}
Provides:		imagemagick = %{version}-%{release}
BuildRequires:  libx11-devel
BuildRequires:  libxext-devel
BuildRequires:  bzip2-devel
BuildRequires:  cairo-devel
BuildRequires:  fontconfig-devel
BuildRequires:  freetype2-devel
BuildRequires:  chrpath
BuildRequires:  graphviz-devel
BuildRequires:  libjbig-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libpng1.6-devel
BuildRequires:  zlib-devel
BuildRequires:  lcms-devel
BuildRequires:  lcms2-devel
BuildRequires:  fftw-devel
BuildRequires:  lqr-devel
BuildRequires:  libltdl-devel
BuildRequires:  perl-devel
BuildRequires:  librsvg-devel
BuildRequires:  tiff-devel
BuildRequires:  libwmf-devel
BuildRequires:  libxml2-devel
BuildRequires:  lzma-devel
BuildRequires:  libopenjpeg-devel
BuildRequires:  libwebp-devel
BuildRequires:  libOpenEXR-devel
%if !%bootstrap
BuildRequires:  djvulibre-devel
%endif
BuildRequires:  ghostscript
BuildRequires:  subversion

%description
ImageMagick is a powerful image display, conversion and manipulation tool. It
runs in an X session. With this tool, you can view, edit and display a variety
of image formats.

ImageMagick can make use of the following delegate programs, available as
packages in %{_vendor}: curl enscript ffmpeg ghostscript ghostscript-X gimp
gnuplot graphviz html2ps mplayer ncompress netpbm sane-backends texlive-texmf
transfig ufraw xdg-utils zip autotrace povray

%package        desktop
Summary:        ImageMagick menus
Group:          Graphics
Requires:       xterm

%description    desktop
This package contains the menu and .desktop entries to run the "display"
command from the menu.

%package -n     %{libname}
Summary:        ImageMagick libraries
Group:          System/Libraries
Provides:       %{_lib}magick = %{version}

%description -n %{libname}
This package contains the libraries needed to run programs dynamically linked
with ImageMagick libraries.

%package -n     %{develname}
Summary:        Static libraries and header files for ImageMagick app development
Group:          Development/Libraries
Requires:       %{libname} = %{version}
Provides:       %{name}-devel = %{version}-%{release}
Provides:		imagemagick-devel = %{version}-%{release}
Provides:       ImageMagick-devel = %{version}-%{release}
Provides:       libmagick-devel = %{version}-%{release}
Provides:       libMagick-devel = %{version}-%{release}
Obsoletes:      ImageMagick-devel
Provides:       libMagick5-devel = %{version}-%{release}
Obsoletes:      libMagick5-devel
Obsoletes:      %{mklibname Magick 8.3.2 -d}
Obsoletes:      %{mklibname magick 10.4.0 -d} %{mklibname Magick 10.4.0 -d}
Obsoletes:      %{mklibname magick 10.7.0 -d} %{mklibname Magick 10.7.0 -d}
Obsoletes:      %{mklibname magick 10.9.0 -d} %{mklibname Magick 10.9.0 -d}

%description -n %{develname}
If you want to create applications that will use ImageMagick code or APIs,
you'll need to install these packages as well as ImageMagick. These additional
packages aren't necessary if you simply want to use ImageMagick, however.

ImageMagick-devel is an addition to ImageMagick which includes static libraries
and header files necessary to develop applications.

%package -n     perl-Image-Magick
Summary:        Libraries and modules for access to ImageMagick from perl
Group:          Development/Perl
Requires:       %{name} = %{version}
Provides:       perl-Magick = %{version}-%{release}
Obsoletes:      perl-Magick

%description -n perl-Image-Magick
This is the ImageMagick perl support package. It includes perl modules and
support files for access to ImageMagick library from perl.

%package        doc
Summary:        %{name} Documentation
Group:          Documentation
BuildArch:      noarch

%description    doc
This package contains HTML/PDF documentation of %{name}.

%prep

%setup -q -n ImageMagick-%{rversion}-%{minor_rev}
%apply_patches

bzcat %{SOURCE1} > ImageMagick.pdf
install -m 644 %{SOURCE10} %{SOURCE11} %{SOURCE12} %{SOURCE13} .
autoreconf -fi

%build
#gw the format-string patch is incomplete:
%define Werror_cflags %nil
%define _disable_ld_no_undefined 1
export CFLAGS="%{optflags} -fno-strict-aliasing -fPIC"
export CXXFLAGS="%{optflags} -fno-strict-aliasing -fPIC"

# don't use icecream
export PATH=/bin:/usr/bin

%configure2_5x \
    --docdir=%{_defaultdocdir}/imagemagick \
    --with-gcc-arch=%{build_arch} \
    --with-pic \
    --enable-shared --disable-static \
    --enable-fast-install \
    --with-threads \
    --with-magick_plus_plus \
    --with-gslib \
    --with-wmf \
    --with-lcms \
    --with-rsvg \
    --with-xml \
    --without-dps \
    --without-windows-font-dir \
    --with-modules \
    --with-perl \
    --with-perl-options="INSTALLDIRS=vendor CC='%{__cc} -L$PWD/magick/.libs' LDDLFLAGS='-shared -L$PWD/magick/.libs'" \
    --with-openjp2 \
    --with-gvc \
    --with-lqr \
    --enable-delegate-build

# Disable rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%make


%install
rm -rf %buildroot
%makeinstall_std LD_RUN_PATH="" pkgdocdir=/installed_docs

# fix docs inclusion (fix an unknown new rpm bug)
rm -rf installed_docs; mv %{buildroot}/installed_docs .

# Remove unpackaged files
find %{buildroot} -name '*.la' -delete

# create compatible symlinks
ln -s libMagick++-%{api}.%{qlev}.so %{buildroot}%{_libdir}/libMagick++.so
ln -s libMagickCore-%{api}.%{qlev}.so %{buildroot}%{_libdir}/libMagickCore.so
ln -s libMagickWand-%{api}.%{qlev}.so %{buildroot}%{_libdir}/libMagickWand.so

%multiarch_binaries %{buildroot}%{_bindir}/Magick++-config
%multiarch_binaries %{buildroot}%{_bindir}/MagickCore-config
%multiarch_binaries %{buildroot}%{_bindir}/MagickWand-config 

# fix invalid rights
chmod 755 %{buildroot}%{perl_vendorarch}/auto/Image/Magick/Q16*/Q16*.so 
chrpath -d %{buildroot}%{perl_vendorarch}/auto/Image/Magick/Q16*/Q16*.so

# icons
install -m 755 -d %{buildroot}%{_liconsdir} \
           %{buildroot}%{_iconsdir} \
           %{buildroot}%{_iconsdir}/hicolor/64x64/apps \
           %{buildroot}%{_miconsdir}
install -m 644 magick-icon_16x16.png %{buildroot}%{_miconsdir}/%{name}.png
install -m 644 magick-icon_32x32.png %{buildroot}%{_iconsdir}/%{name}.png
install -m 644 magick-icon_48x48.png %{buildroot}%{_liconsdir}/%{name}.png
install -m 644 magick-icon_64x64.png %{buildroot}%{_iconsdir}/hicolor/64x64/apps/%{name}.png

# perlmagick: fix perl path of demo files
%{__perl} -MExtUtils::MakeMaker -e 'MY->fixin(@ARGV)' PerlMagick/demo/*.pl

# perlmagick: cleanup various perl tempfiles from the build which get installed
find %{buildroot} -name "*.bs" |xargs rm -f
find %{buildroot} -name ".packlist" |xargs rm -f
find %{buildroot} -name "perllocal.pod" |xargs rm -f 


install -m 755 -d %{buildroot}%{_datadir}/applications/
cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Name=ImageMagick
Comment=Views Graphics files
Exec=%{_bindir}/xterm -geometry 40x15 -title ImageMagick +sb -iconic -e %{_bindir}/display
Icon=%{name}
Terminal=false
Type=Application
Categories=Graphics;Viewer;X-MandrivaLinux-Multimedia-Graphics;
EOF


%files
%doc README.txt
%{_sysconfdir}/ImageMagick-%{api}
%{_bindir}/animate
%{_bindir}/compare
%{_bindir}/composite
%{_bindir}/convert
%{_bindir}/conjure
%{_bindir}/display
%{_bindir}/identify
%{_bindir}/import
%{_bindir}/magick
%{_bindir}/magick-script
%{_bindir}/mogrify
%{_bindir}/montage
%{_bindir}/stream
%{_libdir}/ImageMagick-%{rversion}
%{_datadir}/ImageMagick-%{api}
%{_mandir}/man1/*
%exclude %{_mandir}/man1/*-config.*

%files desktop
%{_datadir}/applications/*
%{_iconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_iconsdir}/hicolor/64x64/apps/%{name}.png

%files -n %{libname}
%{_libdir}/libMagickCore-%{api}.%{qlev}HDRI.so.%{major}*
%{_libdir}/libMagickWand-%{api}.%{qlev}HDRI.so.%{major}*
%{_libdir}/libMagick++-%{api}.%{qlev}HDRI.so.%{cppmajor}*


%files -n %{develname}
%{_includedir}/ImageMagick-%{api} 
%multiarch %{multiarch_bindir}/Magick++-config
%multiarch %{multiarch_bindir}/MagickCore-config
%multiarch %{multiarch_bindir}/MagickWand-config  
%{_bindir}/Magick++-config
%{_bindir}/MagickCore-config
%{_bindir}/MagickWand-config 
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man1/*-config.*


%files -n perl-Image-Magick
%{perl_vendorarch}/Image
%{perl_vendorarch}/auto/Image
%{_mandir}/man3*/*::*.3pm*

%files doc
%doc ImageMagick.pdf ChangeLog LICENSE NEWS* NOTICE
%doc QuickStart.txt installed_docs/*
%doc %{_datadir}/doc/ImageMagick-%{api}

%changelog
* Sat Dec 22 2018 adrianomorselli <adrianomorselli> 7.0.7.0-5uplos2018
- switch to libpng1.6

* Mon Dec 03 2018 adrianomorselli <adrianomorselli> 7.0.7.0-4uplos2018
- rebuild
